package com.yuandian.dataflow.proto.decode;

import java.nio.ByteBuffer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


 
import com.yuandian.dataflow.proto.decode.PacketBase;
import com.yuandian.dataflow.proto.decode.PacketHeader;
 
 


public class BussFlowWeb extends PacketBase {
	private  Integer UNIT_DATA_LENGTH =6104;
	
	private static int i = 1;
	@Override
	public int getUnitPacketLength() {
		return UNIT_DATA_LENGTH;
	}

	@SuppressWarnings("unchecked")
	public BussFlowWeb  Parse(PacketHeader header,ByteBuffer data)
			throws Exception {
		i++;
		BussFlowWeb buss = new BussFlowWeb();
//		buss.m_Header = header;
		
		buss.msg_type = header.getTableID();
//		offset += 4;
//		buss.msg_version = data.getInt(1);
//		offset += 1;
//		buss.msg_seq = data.getInt(4);
//		offset += 4;
//		buss.msg_len = data.getInt(4);
//		offset += 4;
		
		buss.src_mac = data.getLong(8);
	 
		buss.dst_mac = data.getLong(8);
 
 
		data.position(data.position()+20);

		buss.protocol=data.getInt(4);
		 
		buss.bytes_out = data.getLong(4);
		 
		buss.bytes_in = data.getLong(4);
		 
		buss.package_out = data.getInt(4);
		 
		buss.package_in = data.getInt(4);
		 
		buss.session_serial_number = data.alignedSlice(24).toString();   //5268109200
 
//		buss.recog_status = data.getInt(4);
		 
		data.position(data.position()+4);
		buss.req_method = data.getLong(4);      //1
		 
		buss.content_type = data.alignedSlice(40).toString();
		  
		buss.accept = data.alignedSlice(40).toString();  //image/png, image/svg+xml, image/*;q=0.8
		  
		buss.probe_if=data.getInt();
		 
		buss.channel=data.alignedSlice(4).toString();
		  
		buss.session_id=data.alignedSlice(0).toString();  //7Ip6bYet8n0wfxeJMJtAm7v2FW76ZTImJVyNjbYoRbUdUf71QaxQ!-202316728
		 
		buss.request_ip=data.getLong();    //3232235850
		 
		buss.request_port=data.getInt(); //3309
		 
		buss.response_ip=data.getLong();   //1971882754
		 
		buss.response_port=data.getInt(); //80
		 
		//开始时间
		buss.start_tv_sec=data.getLong(); //1492473697
		
		buss.start_tv_usec=data.getLong(); //459461
		
		//结束时间
		buss.end_tv_sec=data.getLong(); //1492473697
		
		buss.end_tv_usec=data.getLong(); //459490
		
		
		buss.server_translate_time=data.getLong();
		 
		
		buss.server_start_tv_sec=data.getInt();
		
		buss.server_start_tv_usec=data.getLong();
		
		//结束时间
		buss.server_end_tv_sec=data.getInt();
		
		buss.server_end_tv_usec=data.getLong();
		
		
		buss.server_response_time=data.getLong();
		 
		buss.client_translate_time=data.getLong();
		 
 
		data.position(data.position()+24);

		buss.x_requested_with = data.alignedSlice(20).toString();
		 
		buss.operating_system=data.alignedSlice(0).toString();                //Windows NT 6.1
		 
		buss.server_res_code=data.getInt();
		
		buss.browser=data.alignedSlice(0).toString();
		 
		buss.isUncomplete = data.getInt(4);
		
		buss.time_flag=data.getInt(4);
		
		int detailMsgLen = data.getInt(4);
		
		int keyMsgLen = data.getInt(4);
		
		int reqMsgLeng= data.getInt(4);
		buss.request_msg_length =reqMsgLeng;
		
		int resMsgLength=data.getInt(4);
		buss.response_msg_length = resMsgLength;
		
		int cookieLength=data.getInt(4);
		buss.req_cookie_leng=cookieLength;
	
		int url_len=data.getInt(4);
	
		int refer_len=data.getInt(4);
		
		int remainLen = data.getInt(4);
		
		
//		if (SystemConfigManager.systemCode.equals("JXYDBPM")) {
//			buss.business_detail_mesg=JXYDBPMDetailMesgUtils.decodeValue(data.alignedSlice(etailMsgLen).toString());
//		} else {
//			buss.business_detail_mesg=data.alignedSlice(etailMsgLen).toString();
//		}
		buss.business_detail_mesg=data.alignedSlice(detailMsgLen).toString();
		 
		buss.bussiness_key_mesg = data.alignedSlice(keyMsgLen).toString();
	 
		buss.request_msg_detail = utils.ByteBufferUTF8String(data,   reqMsgLeng);
	 
		buss.response_msg_detail = utils.ByteBufferUTF8String(data,   resMsgLength);
	 
		buss.req_cookie_detail = data.alignedSlice(cookieLength).toString();
	 
		buss.ori_url=data.alignedSlice(url_len).toString();   // /images/index/220130.gif
		if(buss.ori_url!=null && !"".equals(buss.ori_url.trim())){
			String result = buss.ori_url.replaceAll("\\?", "").replaceAll("\\/", "").replaceAll("\\*", "").replaceAll("\\=", "").replaceAll("\\&", "").replaceAll("\\+", "");
			if(isMessyCode(result)){//如果中文乱码
				// String withoutValue = URLUtil.getInsertURL(buss.ori_url, Constants.SPLIT_NULL).trim();//去参数值

				// String result2 = withoutValue.replaceAll("\\?", "").replaceAll("\\/", "").replaceAll("\\*", "").replaceAll("\\=", "").replaceAll("\\&", "").replaceAll("\\+", "");
				// if(isMessyCode(result2)){//判断是否还乱码
				// 	buss.ori_url="";
				// }else{
				// 	buss.ori_url=withoutValue;
				// }
			};
		}
		 
		buss.reter_url = data.alignedSlice(refer_len).toString();         //  http://www.10086.cn/gd/index_200_200.html
		 
		buss.remain_data = data.alignedSlice(remainLen).toString();
 
		/*if(SystemConfigManager.projectName.contains("GDYDBPM")){
			boolean exist=false;
			if(SystemConfigManager.reduceFlag){
				
				redisTemplate = (RedisTemplate<String, String>) ApplicationContextUtil.getBean("redisTemplate");
				exist = reduceByKey(buss);
			}
			
			//不存在就加入缓存
			if(!exist)return buss;
			//存在就返回空
			return null;
		}
		*/
		
		return buss;
	}


	/**
	 * 如果已经存在这个key，则说明是重复数据，不再进行后续操作
	 * @param buss
	 * @return
	 */
	/*private boolean reduceByKey(BussFlowWeb buss) {
		
		
		String coding = CodingGeneration.md5GenCoding2(buss.ori_url);
		String key=buss.session_serial_number+"|"+buss.request_ip+"|"+buss.request_port+"|"+buss.response_ip+"|"+buss.response_port+"|"+coding+"|"+buss.business_detail_mesg;
		
		//分布式同步锁，如果存在该key或者锁已经被获取则返回false，设置
		
		boolean flag=redisTemplate.opsForValue().setIfAbsent(key, System.currentTimeMillis()+"");
		
		if(flag){
			redisTemplate.expire(key,SystemConfigManager.keyExistTime,TimeUnit.SECONDS);
			//原来不存在这条数据
			return false;
		}
		
		return true;
	}*/
	
	/**
     * 判断字符串是否是乱码
     *
     * @param strName 字符串
     * @return 是否是乱码
     */
    
    public static boolean isMessyCode(String strName) {
        Pattern p = Pattern.compile("\\s*|\t*|\r*|\n*");
        Matcher m = p.matcher(strName);
        String after = m.replaceAll("").replace("-", "").replace("|", "");
        String temp = after.replaceAll("\\p{P}", "");
        char[] ch = temp.trim().toCharArray();
        float chLength = 0 ;
        float count = 0;
        for (int i = 0; i < ch.length; i++) {
            char c = ch[i];
            if (!Character.isLetterOrDigit(c)) {
                if (!isChinese(c)) {
                    count = count + 1;
                }
                chLength++; 
            }
        }
        float result = count / chLength ;
        if (result > 0.4) {
            return true;
        } else {
            return false;
        }
    }
    
    private static boolean isChinese(char c) {
        Character.UnicodeBlock ub = Character.UnicodeBlock.of(c);
        if (ub == Character.UnicodeBlock.CJK_UNIFIED_IDEOGRAPHS
                || ub == Character.UnicodeBlock.CJK_COMPATIBILITY_IDEOGRAPHS
                || ub == Character.UnicodeBlock.CJK_UNIFIED_IDEOGRAPHS_EXTENSION_A
                || ub == Character.UnicodeBlock.GENERAL_PUNCTUATION
                || ub == Character.UnicodeBlock.CJK_SYMBOLS_AND_PUNCTUATION
                || ub == Character.UnicodeBlock.HALFWIDTH_AND_FULLWIDTH_FORMS) {
            return true;
        }
        return false;
    }
	
	public String id; //id
	public int msg_len;                 //消息长度
	public int msg_type;                //消息类型
	public long src_mac;
	public long dst_mac; 
	public int protocol;                //协议名
	public String session_serial_number;//会话序列号			
	public String  buss_type;//业务服务资源编码（C_01）
//	public String  net_segment;//网段标识(客户-web)
	public long request_ip;//Web客户端IP
	public int request_port;//Web客户端端口
	public long  response_ip;//Web服务器IP
	public int response_port;//Web服务器端口
	public long start_tv_sec;//Web开始时间秒
	public long start_tv_usec;//开始时间毫秒
	public long end_tv_sec;//结束时间秒
	public long end_tv_usec;//结束时间微妙
	public String disc_resource_ident;    //web：url   mid:apiBody   db：sql
	public String operating_system;       //web:操作系统   midd：interfaceName  db:db_name 
	//web midd
	public String session_id;//sessionid
	public int request_msg_length;  //请求报文长度
	public String request_msg_detail;   //请求报文详情
	public int response_msg_length; //响应报文长度
	public String response_msg_detail;  //响应报文详情
	//web段
	public String reter_url;           
	public String x_requested_with;
	public long req_method;         //请求方式
	public String content_type;     //请求类型
	public String accept;           //jieshou
	public int req_cookie_leng;//请求cookie报文长度
	public String req_cookie_detail;//请求cookie报文详情
	public long t_intodb_time;
	public int load_or_step;        //0: 页面   1：加载项   2：非web段数据 
	public String business_detail_mesg;
	public String bussiness_key_mesg;  //关键字  格式：key=val|key=val....
	public int isUncomplete;    //组包是否完全    0：组包完整  1：不完整
	public int deal_state=1;
	public int server_res_code;
	public long server_response_time;
	public long client_translate_time;
	public String browser;
	public int server_start_tv_sec;
	public long server_start_tv_usec;
	public int server_end_tv_sec;
	public long server_end_tv_usec;
	public String probe_ip;
	public int probe_if;
	public long server_translate_time;
	public long time_flag;	
	public String channel;
	public String base_code;
	public String ori_url;
	public String remain_data;
	public long bytes_in;
	public long bytes_out;
	public int package_in;
	public int package_out;

	public String  dataId;
	
	public int filterId;

	public String whiteCharacter;

	// tokenId
	public String tokenId;
	// 判断是否是首端资源( 2 )
	public Integer segmentId;
	
	@Override
	public String[] getData() {
		String data[] = new String[38];
		return data;
	}

	public String getBussType() {
		return buss_type;
	}


	@Override
	public int getInterfaceNumber() {
		return 0;
	}
}
